package labss.lang;

import labss.lang.motomondiale.GestioneMotoMondiale;
import labss.lang.motomondiale.model.MotoMondiale;
import labss.lang.motomondiale.model.Nome;
import labss.lang.motomondiale.reflect.MotoMondialeLanguageDeployer;

import org.whole.lang.commons.reflect.CommonsLanguageDeployer;
import org.whole.lang.operations.PrettyPrinterOperation;
import org.whole.lang.queries.model.PathExpression;
import org.whole.lang.queries.util.QueriesUtils;
import org.whole.lang.reflect.ReflectionFactory;
import org.whole.lang.xml.codebase.XmlBuilderPersistenceKit;
import org.whole.langs.core.CoreLanguagesDeployer;
import org.whole.langs.legacy.LegacyLanguagesDeployer;

public abstract class TestMotoMondiale {
	public static void main(String[] args) throws Exception {
		ReflectionFactory.deploy(CommonsLanguageDeployer.class);
		ReflectionFactory.deploy(CoreLanguagesDeployer.class);
		ReflectionFactory.deploy(LegacyLanguagesDeployer.class);
		ReflectionFactory.deploy(MotoMondialeLanguageDeployer.class);

		MotoMondiale mm = (MotoMondiale) XmlBuilderPersistenceKit.instance().readModel(TestMotoMondiale.class.getResourceAsStream("motomondiale2007.xml"));
		PrettyPrinterOperation.prettyPrint(mm);
		
		GestioneMotoMondiale.ricalcolaClassificaPiloti(mm);
		PrettyPrinterOperation.prettyPrint(mm);
		
		GestioneMotoMondiale.stampaClassifiche(mm);
		
		GestioneMotoMondiale.validaPiloti(mm);

		
		System.out.println("\n*** piloti vincenti: (queries)");
		PathExpression pe = (PathExpression) TestQueriesTemplatesFactory.instance().create("nomiPilotiVincenti");
		for (Nome n : QueriesUtils.<Nome>iterator(pe, mm))
			System.out.println("pilota: "+n.getValue());

		
		System.out.println("\n*** team vincenti: (queries)");
		pe = (PathExpression) TestQueriesTemplatesFactory.instance().create("nomiTeamVincenti");
		for (Nome n : QueriesUtils.<Nome>iterator(pe, mm))
			System.out.println("team: "+n.getValue());
	}
}
