package labss.lang;

import org.whole.lang.model.IEntity;
import org.whole.lang.templates.AbstractTemplateFactory;
import org.whole.lang.templates.AbstractTemplateManager;
import org.whole.lang.templates.ITemplateFactory;

public class TestQueriesTemplatesFactory extends AbstractTemplateManager {

    private static class SingletonHolder {
        private static final TestQueriesTemplatesFactory instance = new TestQueriesTemplatesFactory();
    }

    public static TestQueriesTemplatesFactory instance() {
        return SingletonHolder.instance;
    }

    private TestQueriesTemplatesFactory() {
        put("usedVariables", newUsedVariables());
        put("findPiloti", newFindPiloti());
        put("nomiPilotiVincenti", newNomiPilotiVincenti());
        put("nomiTeamVincenti", newNomiTeamVincenti());
    }

    public ITemplateFactory<IEntity> newUsedVariables() {
        return new AbstractTemplateFactory<IEntity>() {

            public void apply(org.whole.lang.builders.IBuilderOperation op) {
                org.whole.lang.queries.builders.IQueriesBuilder b0 = (org.whole.lang.queries.builders.IQueriesBuilder) op.wGetBuilder(org.whole.lang.queries.reflect.QueriesLanguageKit.ID);
                b0.Filter_();
                b0.DescendantOrSelfStep();
                b0.And_();
                b0.TypeTest("Variable");
                b0.DistinctTest();
                b0._And();
                b0._Filter();
            }
        };
    }

    public ITemplateFactory<IEntity> newFindPiloti() {
        return new AbstractTemplateFactory<IEntity>() {

            public void apply(org.whole.lang.builders.IBuilderOperation op) {
                org.whole.lang.queries.builders.IQueriesBuilder b0 = (org.whole.lang.queries.builders.IQueriesBuilder) op.wGetBuilder(org.whole.lang.queries.reflect.QueriesLanguageKit.ID);
                b0.Path_(2);
                b0.FeatureStep("teams");
                b0.Filter_();
                b0.DescendantStep();
                b0.TypeTest("Pilota");
                b0._Filter();
                b0._Path();
            }
        };
    }

    public ITemplateFactory<IEntity> newNomiPilotiVincenti() {
        return new AbstractTemplateFactory<IEntity>() {

            public void apply(org.whole.lang.builders.IBuilderOperation op) {
                org.whole.lang.queries.builders.IQueriesBuilder b0 = (org.whole.lang.queries.builders.IQueriesBuilder) op.wGetBuilder(org.whole.lang.queries.reflect.QueriesLanguageKit.ID);
                b0.Path_(4);
                b0.FeatureStep("calendario");
                b0.ChildStep();
                b0.FeatureStep("ordineDArrivo");
                b0.Filter_();
                b0.ChildStep();
                b0.And_();
                b0.IndexTest_();
                b0.IntLiteral(0);
                b0._IndexTest();
                b0.DistinctTest();
                b0._And();
                b0._Filter();
                b0._Path();
            }
        };
    }

    public ITemplateFactory<IEntity> newNomiTeamVincenti() {
        return new AbstractTemplateFactory<IEntity>() {

            public void apply(org.whole.lang.builders.IBuilderOperation op) {
                org.whole.lang.queries.builders.IQueriesBuilder b0 = (org.whole.lang.queries.builders.IQueriesBuilder) op.wGetBuilder(org.whole.lang.queries.reflect.QueriesLanguageKit.ID);
                b0.Path_(3);
                b0.FeatureStep("teams");
                b0.Filter_();
                b0.ChildStep();
                b0.ExpressionTest_();
                b0.CartesianProduct_(2);
                b0.Path_(5);
                b0.RootStep();
                b0.FeatureStep("calendario");
                b0.ChildStep();
                b0.FeatureStep("ordineDArrivo");
                b0.Filter_();
                b0.ChildStep();
                b0.And_();
                b0.IndexTest_();
                b0.IntLiteral(0);
                b0._IndexTest();
                b0.VariableTest("n");
                b0._And();
                b0._Filter();
                b0._Path();
                b0.Path_(2);
                b0.Filter_();
                b0.ChildStep();
                b0.TypeTest("Pilota");
                b0._Filter();
                b0.Filter_();
                b0.FeatureStep("nome");
                b0.VariableTest("n");
                b0._Filter();
                b0._Path();
                b0._CartesianProduct();
                b0._ExpressionTest();
                b0._Filter();
                b0.FeatureStep("nome");
                b0._Path();
            }
        };
    }
}
