package labss.lang.regexp.reflect;

import org.whole.lang.reflect.AbstractDeployer;
import org.whole.lang.reflect.ReflectionFactory;
import org.whole.lang.builders.IBuilderFactory;
import org.whole.lang.builders.IBuilder;
import org.whole.lang.contexts.IEntityContext;
import labss.lang.regexp.builders.IRegExpBuilder;
import labss.lang.regexp.builders.RegExpGenericBuilderAdapter;
import org.whole.lang.builders.GenericBuilderAdapterOperation;
import labss.lang.regexp.builders.RegExpSpecificBuilderAdapter;
import org.whole.lang.builders.SpecificBuilderAdapterOperation;

/** 
 * @generator Whole
 */
public class RegExpLanguageDeployer extends AbstractDeployer {
	public void deploy(ReflectionFactory platform) {
		platform.addLanguageKit(RegExpLanguageKit.ID);
		platform.addOperationFactory(RegExpLanguageKit.ID,
				GenericBuilderAdapterOperation.ID, new IBuilderFactory() {
					public IBuilder create(IBuilder strategy,
							IEntityContext entityContext) {
						return new RegExpGenericBuilderAdapter(
								(IRegExpBuilder) strategy, entityContext);
					}
				});
		platform.addOperationFactory(RegExpLanguageKit.ID,
				SpecificBuilderAdapterOperation.ID, new IBuilderFactory() {
					public IBuilder create(IBuilder strategy,
							IEntityContext entityContext) {
						return new RegExpSpecificBuilderAdapter(strategy,
								entityContext);
					}
				});
	}

	public void undeploy(ReflectionFactory platform) {
		platform.removeLanguageKit(RegExpLanguageKit.ID);
	}
}
