package labss.lang.regexp.visitors;

import org.whole.lang.visitors.GenericTraversalFactory;
import org.whole.lang.visitors.IVisitor;
import org.whole.lang.visitors.IBinaryVisitor;
import org.whole.lang.visitors.IUnaryVisitor;

/** 
 * @generator Whole
 */
public class RegExpTraversalFactory extends GenericTraversalFactory {
	public static final RegExpTraversalFactory instance = new RegExpTraversalFactory();

	private RegExpTraversalFactory() {
	}

	protected IVisitor ensureSpecific(IVisitor visitor) {
		if (visitor instanceof IRegExpVisitor)
			return visitor;
		else
			return new RegExpForwardGenericVisitor(visitor);
	}

	public IVisitor failure() {
		return new RegExpFailureVisitor();
	}

	public IVisitor identity() {
		return new RegExpIdentityVisitor();
	}

	public IVisitor forwardStaged() {
		return new RegExpForwardStagedVisitor();
	}

	public IBinaryVisitor sequence(IVisitor visitor1, IVisitor visitor2) {
		return new RegExpSequenceVisitor(ensureSpecific(visitor1),
				ensureSpecific(visitor2));
	}

	public IUnaryVisitor traverseAll(IVisitor visitor1) {
		return new RegExpTraverseAllVisitor(ensureSpecific(visitor1));
	}
}
